var { init, buildPrefsWidget } =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = imports.gi.GLib;


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(2);


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Gtk_3_0_1 = __webpack_require__(3);
const GdkPixbuf_2_0_1 = __webpack_require__(4);
const GLib_2_0_1 = __webpack_require__(0);
const utils_1 = __webpack_require__(5);
const shell_1 = __webpack_require__(7);
const Wnck_3_0_1 = __webpack_require__(8);
const debug = utils_1.logger('prefs');
class Preferences {
    constructor() {
        var _a;
        this.mttData = [];
        this.extension = shell_1.getCurrentExtension();
        this.settings = shell_1.getCurrentExtensionSettings();
        // Create a parent widget
        this.widget = new Gtk_3_0_1.Box();
        // Load ui from glade file
        this.builder = Gtk_3_0_1.Builder.new_from_file(`${this.extension.path}/ui/prefs.glade`);
        // Connect all events
        this.builder.connect_signals_full((builder, object, signal, handler) => {
            object.connect(signal, this[handler].bind(this));
        });
        this.trackedClassesListBox = this.builder.get_object('tracked-classes-listbox');
        const settingsBox = this.builder.get_object('mtt-settings');
        this.widget.pack_start(settingsBox, true, true, 0);
        (_a = this.widget.get_parent_window()) === null || _a === void 0 ? void 0 : _a.set_title(this.extension.metadata.name);
        // Initialize values
        this.initValues();
    }
    initValues() {
        try {
            // Get the already saved data
            this.mttData = JSON.parse(this.settings.get_string('mtt-data'));
        }
        catch (_) {
            debug('could not parse the settings data, resetting it.');
            this.mttData = [];
        }
        // Create ui row for each item
        this.mttData.forEach((data) => {
            this.addRow(data.className, data.enabled, this.createIcon(data.icon));
        });
        debug('initialized values');
    }
    onAddApplication() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                // Get the window id and the window
                const windowId = yield utils_1.getWindowXid();
                // Get the class name
                const className = yield utils_1.getWindowClassName(windowId);
                // Check if class name is already included
                if (this.mttData.findIndex((data) => data.className === className) >= 0) {
                    return;
                }
                // Get the icon
                const icon = this.getIconFromWindow(windowId);
                // Add row to list
                this.addRow(className, true, icon);
                // Add data to mttData
                this.mttData.push({
                    className,
                    enabled: true,
                    icon: icon && GLib_2_0_1.base64_encode(icon.get_pixels()),
                });
            }
            catch (ex) {
                debug(`exception: ${ex}`);
            }
        });
    }
    onSave() {
        this.settings.set_string('mtt-data', JSON.stringify(this.mttData));
        this.onClose();
    }
    onClose() {
        this.widget.get_toplevel().destroy();
    }
    addRow(className, enabled, appIcon) {
        const rowBuilder = Gtk_3_0_1.Builder.new_from_file(`${this.extension.path}/ui/row_template.glade`);
        // Get the template
        const row = rowBuilder.get_object('row-template');
        // Set the class name
        const classNameLabel = rowBuilder.get_object('class-name-label');
        classNameLabel.set_text(className);
        // Set the icon
        if (appIcon) {
            const iconImage = rowBuilder.get_object('icon-image');
            iconImage.set_from_pixbuf(appIcon);
        }
        // Set the enabled switch
        const enabledSwitch = rowBuilder.get_object('enabled-switch');
        enabledSwitch.set_active(enabled);
        // Connect to state set event for changes
        enabledSwitch.connect('state-set', (_, state) => {
            this.mttData.forEach((data) => {
                if (data.className === className) {
                    data.enabled = state;
                }
            });
        });
        // Connect remove event
        const removeButton = rowBuilder.get_object('remove-button');
        removeButton.connect('clicked', () => {
            this.trackedClassesListBox.remove(row);
            this.mttData = this.mttData.filter((data) => data.className !== className);
        });
        // Add to existing list
        this.trackedClassesListBox.insert(row, 0);
    }
    createIcon(iconBase64) {
        if (iconBase64) {
            return GdkPixbuf_2_0_1.Pixbuf.new_from_bytes(GLib_2_0_1.base64_decode(iconBase64), GdkPixbuf_2_0_1.Colorspace.RGB, true, 8, 32, 32, 128);
        }
    }
    getIconFromWindow(xid) {
        var _a;
        (_a = Wnck_3_0_1.Screen.get_default()) === null || _a === void 0 ? void 0 : _a.force_update();
        const window = Wnck_3_0_1.Window.get(parseInt(xid));
        if (!window || window.get_icon_is_fallback()) {
            debug(`getting icon for window ${xid}`);
            // Get the icon from window
            const defaulIcon = Gtk_3_0_1.IconTheme.get_default().lookup_icon('applications-system-symbolic', 32, Gtk_3_0_1.IconLookupFlags.USE_BUILTIN);
            return defaulIcon === null || defaulIcon === void 0 ? void 0 : defaulIcon.load_icon();
        }
        return window.get_icon();
    }
}
const init = () => {
    debug('prefs initialized');
};
const buildPrefsWidget = () => {
    const prefs = new Preferences();
    prefs.widget.show_all();
    return prefs.widget;
};
exports.default = { init, buildPrefsWidget };


/***/ }),
/* 3 */
/***/ (function(module, exports) {

module.exports = imports.gi.Gtk;


/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = imports.gi.GdkPixbuf;


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.guessWindowXID = exports.getWindowXid = exports.getWindowClassName = exports.execute = exports.clearTimeout = exports.setTimeout = exports.clearInterval = exports.setInterval = exports.logger = void 0;
const Gio_2_0_1 = __webpack_require__(6);
const GLib_2_0_1 = __webpack_require__(0);
exports.logger = (prefix) => (content) => log(`[mtt] [${prefix}] ${content}`);
exports.setInterval = (func, millis) => {
    const id = GLib_2_0_1.timeout_add(GLib_2_0_1.PRIORITY_DEFAULT, millis, () => {
        func();
        return true;
    });
    return id;
};
exports.clearInterval = (id) => GLib_2_0_1.Source.remove(id);
exports.setTimeout = (func, millis) => {
    return GLib_2_0_1.timeout_add(GLib_2_0_1.PRIORITY_DEFAULT, millis, () => {
        func();
        return false;
    });
};
exports.clearTimeout = (id) => GLib_2_0_1.Source.remove(id);
exports.execute = (command) => __awaiter(void 0, void 0, void 0, function* () {
    const process = new Gio_2_0_1.Subprocess({
        argv: ['bash', '-c', command],
        flags: Gio_2_0_1.SubprocessFlags.STDOUT_PIPE,
    });
    process.init(null);
    return new Promise((resolve, reject) => {
        process.communicate_utf8_async(null, null, (_, result) => {
            const [, stdout, stderr] = process.communicate_utf8_finish(result);
            if (stderr) {
                reject(stderr);
            }
            else if (stdout) {
                resolve(stdout.trim());
            }
            else {
                resolve();
            }
        });
    });
});
exports.getWindowClassName = (xid) => __awaiter(void 0, void 0, void 0, function* () {
    const xpropOut = yield exports.execute(`xprop -id ${xid} WM_CLASS`);
    return xpropOut.split('=')[1].split(',')[0].trim().split('"')[1];
});
exports.getWindowXid = () => __awaiter(void 0, void 0, void 0, function* () {
    return exports.execute('xdotool selectwindow');
});
/**
 * Taken from pixel saver extension. https://github.com/pixel-saver/pixel-saver
 *
 * Guesses the X ID of a window.
 */
exports.guessWindowXID = (window) => __awaiter(void 0, void 0, void 0, function* () {
    // We cache the result so we don't need to redetect.
    // if (window._mttWindowId) {
    //   return window._mttWindowId;
    // }
    /**
     * If window title has non-utf8 characters, get_description() complains
     * "Failed to convert UTF-8 string to JS string: Invalid byte sequence in conversion input",
     * event though get_title() works.
     */
    try {
        const m = window.get_description().match(/0x[0-9a-f]+/);
        if (m && m[0]) {
            // return (win._pixelSaverWindowID = m[0]);
            return m[0];
        }
    }
    catch (err) { }
    // use xwininfo, take first child.
    const act = window.get_compositor_private();
    const xwindow = act && act['x-window'];
    if (xwindow) {
        const xwininfo = yield exports.execute(`xwininfo -children -id 0x${xwindow}`);
        if (xwininfo[0]) {
            const str = xwininfo[1].toString();
            /**
             * The X ID of the window is the one preceding the target window's title.
             * This is to handle cases where the window has no frame and so
             * act['x-window'] is actually the X ID we want, not the child.
             */
            const regexp = new RegExp(`(0x[0-9a-f]+) +"${window.title}"`);
            let m = str.match(regexp);
            if (m && m[1]) {
                // return (win._pixelSaverWindowID = m[1]);
                return m[1];
            }
            // Otherwise, just grab the child and hope for the best
            m = str.split(/child(?:ren)?:/)[1].match(/0x[0-9a-f]+/);
            if (m && m[0]) {
                // return (win._pixelSaverWindowID = m[0]);
                return m[0];
            }
        }
    }
    // Try enumerating all available windows and match the title. Note that this
    // may be necessary if the title contains special characters and `x-window`
    // is not available.
    const result = yield exports.execute('xprop -root _NET_CLIENT_LIST');
    if (result[0]) {
        const str = result[1].toString();
        // Get the list of window IDs.
        const windowList = str.match(/0x[0-9a-f]+/g);
        if (windowList) {
            // For each window ID, check if the title matches the desired title.
            for (let i = 0; i < windowList.length; ++i) {
                const result = yield exports.execute(`xprop -id "${windowList[i]}" _NET_WM_NAME`);
                if (result[0]) {
                    const output = result[1].toString();
                    const title = output.match(/_NET_WM_NAME(\(\w+\))? = "(([^\\"]|\\"|\\\\)*)"/);
                    // Is this our guy?
                    if (title && title[2] == window.title) {
                        return windowList[i];
                    }
                }
            }
        }
    }
});


/***/ }),
/* 6 */
/***/ (function(module, exports) {

module.exports = imports.gi.Gio;


/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.getCurrentExtensionSettings = exports.getCurrentExtension = exports.ExtensionState = exports.ExtensionType = void 0;
var ExtensionType;
(function (ExtensionType) {
    ExtensionType[ExtensionType["SYSTEM"] = 1] = "SYSTEM";
    ExtensionType[ExtensionType["PER_USER"] = 2] = "PER_USER";
})(ExtensionType = exports.ExtensionType || (exports.ExtensionType = {}));
var ExtensionState;
(function (ExtensionState) {
    ExtensionState[ExtensionState["ENABLED"] = 1] = "ENABLED";
    ExtensionState[ExtensionState["DISABLED"] = 2] = "DISABLED";
    ExtensionState[ExtensionState["ERROR"] = 3] = "ERROR";
    ExtensionState[ExtensionState["OUT_OF_DATE"] = 4] = "OUT_OF_DATE";
    ExtensionState[ExtensionState["DOWNLOADING"] = 5] = "DOWNLOADING";
    ExtensionState[ExtensionState["INITIALIZED"] = 6] = "INITIALIZED";
    // Used as an error state for operations on unknown extensions,
    // should never be in a real extensionMeta object.
    ExtensionState[ExtensionState["UNINSTALLED"] = 99] = "UNINSTALLED";
})(ExtensionState = exports.ExtensionState || (exports.ExtensionState = {}));
exports.getCurrentExtension = () => imports.misc.extensionUtils.getCurrentExtension();
exports.getCurrentExtensionSettings = () => imports.misc.extensionUtils.getSettings();


/***/ }),
/* 8 */
/***/ (function(module, exports) {

module.exports = imports.gi.Wnck;


/***/ })
/******/ ])["default"];